﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _02DAMSample
{
    public partial class Form1 : Form
    {
        private short DevId;        // Device Id
        private WaveSet WaveSetDlg;
        public Form1()
        {
            InitializeComponent();
            WaveSetDlg = new WaveSet();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Function_Enable(false); //***
            IDNUM.SelectedIndex = 0; //***初期選択IDを0にする
        }

        private void Function_Enable(Boolean en)
        {
            //***オープンとID選択ボタンのみを無効にする。***
            DevOpen.Enabled = !en; //***オープンボタン無効
            DevClose.Enabled = en; //***クローズボタン有効
            IDNUM.Enabled = !en; //***ID選択ボタン無効
            //***以下のボタンすべて有効
            PioDirection.Enabled = en;
            PioWrite.Enabled = en;
            PioRead.Enabled = en;
            DAC1Range1.Enabled = en;
            DAC1Range2.Enabled = en;
            DAC1Range3.Enabled = en;
            DAC1Range4.Enabled = en;
            DAC1Range5.Enabled = en;
            DAC1SingleOut.Enabled = en;
            DAC2Range1.Enabled = en;
            DAC2Range2.Enabled = en;
            DAC2Range3.Enabled = en;
            DAC2Range4.Enabled = en;
            DAC2Range5.Enabled = en;
            DAC2SingleOut.Enabled = en;

            DACSingleShot.Enabled = en;
            DACStart.Enabled = en;
            DACStop.Enabled = en;
        }

        private void DevOpen_Click(object sender, EventArgs e)
        {
            byte pol;
            byte range;
            short retErr;


            //***デバイスのオープン***f
            DevId = (short) IDNUM.SelectedIndex;
            retErr = TUSBDAM.Tusbdam_Device_Open(DevId);
            if(retErr == 0)
            {
                Function_Enable(true); //***各機能ボタンを有効にする
                retErr = TUSBDAM.Tusbdam_Range_Read(DevId, 1, out pol, out range);
                if( retErr == 0 )
                {
                    if( pol == 0 )
                    {
                        if( range == 0 )
                            DAC1Range1.Checked = true;
                        else
                            DAC1Range2.Checked = true;
                    }
                    else
                    {
                        if( range == 0 )
                            DAC1Range3.Checked = true;
                        else if( range == 1)
                            DAC1Range4.Checked = true;
                        else
                            DAC1Range5.Checked = true;
                    }
                }
                else
                {
                    DeviceClose();
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr));
                    return;
                }

                retErr = TUSBDAM.Tusbdam_Range_Read(DevId, 2, out pol, out range);
                if( retErr == 0 )
                {
                    if( pol == 0 )
                    {
                        if( range == 0 )
                            DAC2Range1.Checked = true;
                        else
                            DAC2Range2.Checked = true;
                    }
                    else
                    {
                        if( range == 0 )
                            DAC2Range3.Checked = true;
                        else if( range == 1)
                            DAC2Range4.Checked = true;
                        else
                            DAC2Range5.Checked = true;
                    }
                }
                else
                {
                    DeviceClose();
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr));
                    return;
                }
            }
            else
                MessageBox.Show(TUSBDAM.GetOpenErrMessage(retErr)); //***オープンに失敗した場合
        }

        private void DeviceClose()
        {
            TUSBDAM.Tusbdam_Device_Close(DevId); //***デバイスクローズ
            Function_Enable(false); //***ボタンの有効無効切り替え 
        }

        private void DevClose_Click(object sender, EventArgs e)
        {
            DeviceClose();
        }

        private void PioDirection_Click(object sender, EventArgs e)
        {
            //***PIOディレクション書きこみ
            string Ret;
            byte Dat;
            InBox InputTxtBox =new InBox();
            short retErr;

            Ret = InputTxtBox.GetText("ディレクションの出力値を入力してください(HEX)", "PIO Direction", "0");
            if( Ret.Length > 0) //文字が返ってきているか
            {
                if (Byte.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, null, out Dat))
                {
                    if(Dat >= 0 && Dat <= 0xff) //*** データの範囲にあるか
                    {
                        retErr = TUSBDAM.Tusbdam_Pio_Direction(DevId, Dat);//***DLL関数の実行
                        if (retErr != 0) 
                        {
                            MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                            DeviceClose();
                        }
                    }
                    else
                        MessageBox.Show("データの範囲は0～ff(HEX)です。");
                }
                else
                    MessageBox.Show("データの形式に誤りがあります->(" + Ret + ")");
            }
        }

        private void PioWrite_Click(object sender, EventArgs e)
        {
            //***PIO出力データ書きこみ
            string Ret;
            byte Dat;
            InBox InputTxtBox = new InBox();
            short retErr;

            Ret = InputTxtBox.GetText("出力値を入力してください(HEX)", "PIO Write", "0");
            if( Ret.Length > 0 ) //文字が返ってきているか
            {
                if(Byte.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, null, out Dat))
                {
                    if(Dat >= 0 && Dat <= 0xff) //*** データの範囲にあるか
                    {
                        retErr = TUSBDAM.Tusbdam_Pio_Write(DevId, Dat);
                        if( retErr != 0 ) //***DLL関数の実行
                        {
                            MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                            DeviceClose();
                        }
                    }
                    else
                        MessageBox.Show("データの範囲は0～ff(HEX)です。");
                }
                else
                    MessageBox.Show("データの形式に誤りがあります->(" + Ret + ")");
            }
        }

        private void PioRead_Click(object sender, EventArgs e)
        {
            //***入力データの取得
            byte dat;
            short retErr;

            retErr = TUSBDAM.Tusbdam_Pio_Read(DevId, out dat);
            if (retErr != 0) //***DLL関数の実行
            {
                MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); //***書きこみ失敗
                DeviceClose();
            }
            else
                MessageBox.Show("入力値は " + dat.ToString("X") + "(HEX) です");
        }

        private void DAC1Range_CheckedChange(object sender, EventArgs e)
        {
            short retErr;
            byte ch;
            byte pol;
            byte range;

            ch = 1;

            if(DAC1Range1.Checked )// 0-5
            {
                pol = 0;
                range = 0;
            }
            else if(DAC1Range2.Checked)//0-10
            {
                pol = 0;
                range = 1;
            }
            else if(DAC1Range3.Checked)//+/- 2.5
            {
                pol = 1;
                range = 0;
            }
            else if(DAC1Range4.Checked)//+/- 5
            {
                pol = 1;
                range = 1;
            }
            else if(DAC1Range5.Checked)//+/- 10
            {
                pol = 1;
                range = 2;
            }
            else
            {
                pol = 0;
                range = 0;
            }

            retErr = TUSBDAM.Tusbdam_Range_Set(DevId, ch, pol, range);

            if( retErr != 0 )
            {
                MessageBox.Show(TUSBDAM.GetErrMessage(retErr));
                DeviceClose();
            }
        }

        private void DAC2Range_CheckedChange(object sender, EventArgs e)
        {
            short retErr;
            byte ch;
            byte pol;
            byte range;

            ch = 2;

            if (DAC2Range1.Checked)// 0-5
            {
                pol = 0;
                range = 0;
            }
            else if (DAC2Range2.Checked)//0-10
            {
                pol = 0;
                range = 1;
            }
            else if (DAC2Range3.Checked)//+/- 2.5
            {
                pol = 1;
                range = 0;
            }
            else if (DAC2Range4.Checked)//+/- 5
            {
                pol = 1;
                range = 1;
            }
            else if (DAC2Range5.Checked)//+/- 10
            {
                pol = 1;
                range = 2;
            }
            else
            {
                pol = 0;
                range = 0;
            }

            retErr = TUSBDAM.Tusbdam_Range_Set(DevId, ch, pol, range);

            if (retErr != 0)
            {
                MessageBox.Show(TUSBDAM.GetErrMessage(retErr));
                DeviceClose();
            }
        }

        private void DAC1SingleOut_Click(object sender, EventArgs e)
        {
            //***DAC1シングル出力データ書きこみ
            string Ret;
            int Dat;
            InBox InputTxtBox = new InBox();
            short retErr;

            Ret = InputTxtBox.GetText("出力値を入力してください(HEX)", "DAC1SingleOut", "0");
            if( Ret.Length > 0 ) //***OKで返ってきているか
            {
                if( int.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, null, out Dat) )
                {
                    if(Dat >= 0 && Dat <= 0xfff) //*** データの範囲にあるか
                    {
                        retErr = TUSBDAM.Tusbdam_Single_Out(DevId, 1, Dat); //***DLL関数の実行
                        if( retErr != 0 ) //***DLL関数の実行
                        {
                            MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                            DeviceClose();
                        }
                    }
                    else
                        MessageBox.Show("データの範囲は0～fff(HEX)です。");
                }
                else
                    MessageBox.Show("データの形式に誤りがあります->(" + Ret + ")");
            }
        }

        private void DAC2SingleOut_Click(object sender, EventArgs e)
        {
            //***DAC2シングル出力データ書きこみ
            string Ret;
            int Dat;
            InBox InputTxtBox = new InBox();
            short retErr;

            Ret = InputTxtBox.GetText("出力値を入力してください(HEX)", "DAC2SingleOut", "0");
            if (Ret.Length > 0) //***OKで返ってきているか
            {
                if (int.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, null, out Dat))
                {
                    if (Dat >= 0 && Dat <= 0xfff) //*** データの範囲にあるか
                    {
                        retErr = TUSBDAM.Tusbdam_Single_Out(DevId, 2, Dat); //***DLL関数の実行
                        if (retErr != 0) //***DLL関数の実行
                        {
                            MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                            DeviceClose();
                        }
                    }
                    else
                        MessageBox.Show("データの範囲は0～fff(HEX)です。");
                }
                else
                    MessageBox.Show("データの形式に誤りがあります->(" + Ret + ")");
            }
        }

        //矩形波生成
        private double RectangleF(double Arg)
        {
            Arg /= 2.0 * Math.PI; //スケール2Pi->1変換
            Arg -= Math.Floor(Arg); // 鋸波形に変換
            if (Arg < 0.5)
                return 1.0;
            else
                return -1.0;
        }

        //三角波生成
        private double TriangleF(double Arg)
        {
            Arg /= 2.0 * Math.PI; //スケール2Pi->1変換
            Arg -= Math.Floor(Arg); //鋸刃波形に変換
            Arg *= 4.0; //スケール1 -> 4変換
            if (Arg < 1.0)
                return Arg;
            else if (Arg < 3.0)
                return (2.0 - Arg);
            else
                return (Arg - 4.0);
        }

        //波形生成
        private void GenWave(ref int[] data, byte Shape, short Leng, short Amp, short OFFSET)
        {
            int cnt;
            double angle;

            for (cnt = 0; cnt < Leng; cnt++)
            {
                angle = 2.0 * Math.PI * (double)cnt / (double)Leng;
                switch (Shape)
                {
                    case 0://正弦波
                        data[cnt] = (int)(Amp * System.Math.Sin(angle) + OFFSET);
                        break;
                    case 1://三角波
                        data[cnt] = (int)(Amp * TriangleF(angle) + OFFSET);
                        break;
                    case 2://矩形波
                        data[cnt] = (int)(Amp * RectangleF(angle) + OFFSET);
                        break;
                    default:
                        data[cnt] = 0;
                        break;
                }
            }
        }

        private void DACStart_Click(object sender, EventArgs e)
        {
            int i;
            int[] data = new int[8200];
            short retErr;

            if( WaveSetDlg.ShowDialog() == DialogResult.OK )
            {
                //*** 波形発生停止(動いていた場合のため)
                retErr = TUSBDAM.Tusbdam_Stop(DevId);//***DLL関数の実行
                if( retErr != 0 )
                {
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                    DeviceClose();
                }

                //*** サンプルクロック設定
                retErr = TUSBDAM.Tusbdam_Clock_Set(DevId, WaveSetDlg.ClkSel, WaveSetDlg.IntClock);
                if( retErr != 0 ) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                    DeviceClose();
                }

                //*** 波形を生成
                GenWave(ref data, WaveSetDlg.WaveType, WaveSetDlg.DataLen, WaveSetDlg.Amp , 2048);

                //*** DAC変換範囲に制限する処理
                for( i = 0 ; i < WaveSetDlg.DataLen ; i++ )
                {
                    if( data[i] > 4095 )
                        data[i] = 4095;
                    else if( data[i] < 0 )
                        data[i] = 0;
                }

                //*** 同期出力が有る場合の同期ビット付加
                if( WaveSetDlg.SyncChk )
                {
                    for (i = 0; i < (WaveSetDlg.DataLen / 2); i++)
                        data[i] = data[i] + 0x8000;
                }

                //*** ch1メモリに波形設定
                retErr = TUSBDAM.Tusbdam_Set_Memory(DevId, 1, WaveSetDlg.DataLen, data);
                if( retErr != 0 )
                {
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                    DeviceClose();
                }

                //*** ch2メモリに波形設定
                retErr = TUSBDAM.Tusbdam_Set_Memory(DevId, 2, WaveSetDlg.DataLen, data);
                if( retErr != 0 )
                {
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                    DeviceClose();
                }

                //*** データ長設定
                retErr = TUSBDAM.Tusbdam_Cycle_Set(DevId, WaveSetDlg.DataLen);
                if( retErr != 0 )
                {
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                    DeviceClose();
                }

                //*** 波形発生開始
                retErr = TUSBDAM.Tusbdam_Start(DevId, WaveSetDlg.OutputCont);
                if( retErr != 0 ) //***DLL関数の実行
                {
                    MessageBox.Show(TUSBDAM.GetErrMessage(retErr)); 
                    DeviceClose();
                }
            }
        }

        private void DACSingleShot_Click(object sender, EventArgs e)
        {
            short retErr;

            retErr = TUSBDAM.Tusbdam_Single_Shot(DevId);
            if (retErr != 0) //***DLL関数の実行
            {
                MessageBox.Show(TUSBDAM.GetErrMessage(retErr));
                DeviceClose();
            }
        }

        private void DACStop_Click(object sender, EventArgs e)
        {
            short retErr;

            retErr = TUSBDAM.Tusbdam_Stop(DevId);
            if (retErr != 0) //***DLL関数の実行
            {
                MessageBox.Show(TUSBDAM.GetErrMessage(retErr));
                DeviceClose();
            }
        }
    }
}
