﻿Public Class Form1
    Public DevId As Short           'Device Id
    Private WaveSetDlg As WaveSet

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

        WaveSetDlg = New WaveSet
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Function_Enable(False) '***
        IDNUM.SelectedIndex = 0 '***初期選択IDを0にする
    End Sub

    Private Sub Function_Enable(ByVal en As Boolean)
        DevOpen.Enabled = Not en '***オープンボタン
        DevClose.Enabled = en '***クローズボタン
        IDNUM.Enabled = Not en '***ID選択ボタン
        PioDirection.Enabled = en
        PioWrite.Enabled = en
        PioRead.Enabled = en
        DAC1Range1.Enabled = en
        DAC1Range2.Enabled = en
        DAC1Range3.Enabled = en
        DAC1Range4.Enabled = en
        DAC1Range5.Enabled = en
        DAC1SingleOut.Enabled = en
        DAC2Range1.Enabled = en
        DAC2Range2.Enabled = en
        DAC2Range3.Enabled = en
        DAC2Range4.Enabled = en
        DAC2Range5.Enabled = en
        DAC2SingleOut.Enabled = en

        DACSingleShot.Enabled = en
        DACStart.Enabled = en
        DACStop.Enabled = en
    End Sub

    Private Sub DevOpen_Click(sender As System.Object, e As System.EventArgs) Handles DevOpen.Click
        Dim pol As Byte
        Dim range As Byte
        Dim retErr As Short

        '***デバイスのオープン***f
        DevId = CShort(IDNUM.SelectedIndex)
        retErr = Tusbdam_Device_Open(DevId)
        If (retErr = 0) Then
            Function_Enable(True) '***各機能ボタンを有効にする
            retErr = Tusbdam_Range_Read(DevId, 1, pol, range)
            If retErr <> 0 Then '***DLL関数の実行
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            Else
                If pol = 0 Then
                    If range = 0 Then
                        DAC1Range1.Checked = True
                    Else
                        DAC1Range2.Checked = True
                    End If
                Else
                    If range = 0 Then
                        DAC1Range3.Checked = True
                    ElseIf range = 1 Then
                        DAC1Range4.Checked = True
                    Else
                        DAC1Range5.Checked = True
                    End If
                End If
            End If

            retErr = Tusbdam_Range_Read(DevId, 2, pol, range)
            If retErr <> 0 Then '***DLL関数の実行
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            Else
                If pol = 0 Then
                    If range = 0 Then
                        DAC2Range1.Checked = True
                    Else
                        DAC2Range2.Checked = True
                    End If
                Else
                    If range = 0 Then
                        DAC2Range3.Checked = True
                    ElseIf range = 1 Then
                        DAC2Range4.Checked = True
                    Else
                        DAC2Range5.Checked = True
                    End If
                End If
            End If
        Else
            Tusbdam_OpenErrorDisp(retErr) '***オープンに失敗した場合
        End If
    End Sub

    Private Sub DeviceClose()
        Tusbdam_Device_Close(DevId) '***デバイスクローズ
        Function_Enable(False) '***ボタンの有効無効切り替え
    End Sub

    Private Sub DevClose_Click(sender As System.Object, e As System.EventArgs) Handles DevClose.Click
        DeviceClose()
    End Sub

    Private Sub PioDirection_Click(sender As System.Object, e As System.EventArgs) Handles PioDirection.Click
        '***PIOディレクション書きこみ
        Dim Ret As String
        Dim Dat As Byte
        Dim InputTxtBox As New InBox
        Dim retErr As Short

        Ret = InputTxtBox.GetText("ディレクションの出力値を入力してください(HEX)", "PIO Direction", "0")
        If Ret.Length > 0 Then '文字が返ってきているか
            If (Byte.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, Nothing, Dat)) Then
                If (Dat >= 0 And Dat <= &HFFS) Then '*** データの範囲にあるか
                    retErr = Tusbdam_Pio_Direction(DevId, Dat)
                    If retErr <> 0 Then '***DLL関数の実行
                        Tusbdam_ErrorDisp(retErr)
                        DeviceClose()
                    End If
                Else
                    MessageBox.Show("データの範囲は0～ff(HEX)です。")
                End If
            Else
                MessageBox.Show("データの形式に誤りがあります->(" + Ret + ")")
            End If
        End If
    End Sub

    Private Sub PioWrite_Click(sender As System.Object, e As System.EventArgs) Handles PioWrite.Click
        '***PIO出力データ書きこみ
        Dim Ret As String
        Dim Dat As Byte
        Dim InputTxtBox As New InBox
        Dim retErr As Short

        Ret = InputTxtBox.GetText("出力値を入力してください(HEX)", "PIO Write", "0")
        If Ret.Length > 0 Then '文字が返ってきているか
            If (Byte.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, Nothing, Dat)) Then
                If (Dat >= 0 And Dat <= &HFFS) Then '*** データの範囲にあるか
                    retErr = Tusbdam_Pio_Write(DevId, Dat)
                    If retErr <> 0 Then '***DLL関数の実行
                        Tusbdam_ErrorDisp(retErr)
                        DeviceClose()
                    End If
                Else
                    MessageBox.Show("データの範囲は0～ff(HEX)です。")
                End If
            Else
                MessageBox.Show("データの形式に誤りがあります->(" + Ret + ")")
            End If
        End If
    End Sub

    Private Sub PioRead_Click(sender As System.Object, e As System.EventArgs) Handles PioRead.Click
        '***入力データの取得
        Dim dat As Byte
        Dim retErr As Short

        retErr = Tusbdam_Pio_Read(DevId, dat)
        If retErr <> 0 Then '***DLL関数の実行
            Tusbdam_ErrorDisp(retErr) '***書きこみ失敗
            DeviceClose()
        Else
            MessageBox.Show("入力値は " + dat.ToString("X") + "(HEX) です")
        End If
    End Sub

    Private Sub DAC1Range_CheckedChange(sender As System.Object, e As System.EventArgs) Handles DAC1Range1.CheckedChanged, DAC1Range5.CheckedChanged, DAC1Range4.CheckedChanged, DAC1Range3.CheckedChanged, DAC1Range2.CheckedChanged
        Dim retErr As Short
        Dim ch As Byte
        Dim pol As Byte
        Dim range As Byte

        ch = 1

        If DAC1Range1.Checked Then ' 0-5
            pol = 0
            range = 0
        ElseIf DAC1Range2.Checked Then '0-10
            pol = 0
            range = 1
        ElseIf DAC1Range3.Checked Then '+/- 2.5
            pol = 1
            range = 0
        ElseIf DAC1Range4.Checked Then '+/- 5
            pol = 1
            range = 1
        ElseIf DAC1Range5.Checked Then '+/- 10
            pol = 1
            range = 2
        Else
            pol = 0
            range = 0
        End If

        retErr = Tusbdam_Range_Set(DevId, ch, pol, range)

        If retErr <> 0 Then
            Tusbdam_ErrorDisp(retErr)
            DeviceClose()
        End If
    End Sub

    Private Sub DAC2Range_CheckedChange(sender As System.Object, e As System.EventArgs) Handles DAC2Range5.CheckedChanged, DAC2Range4.CheckedChanged, DAC2Range3.CheckedChanged, DAC2Range2.CheckedChanged, DAC2Range1.CheckedChanged
        Dim retErr As Short
        Dim ch As Byte
        Dim pol As Byte
        Dim range As Byte

        ch = 2

        If DAC2Range1.Checked Then ' 0-5
            pol = 0
            range = 0
        ElseIf DAC2Range2.Checked Then '0-10
            pol = 0
            range = 1
        ElseIf DAC2Range3.Checked Then '+/- 2.5
            pol = 1
            range = 0
        ElseIf DAC2Range4.Checked Then '+/- 5
            pol = 1
            range = 1
        ElseIf DAC2Range5.Checked Then '+/- 10
            pol = 1
            range = 2
        Else
            pol = 0
            range = 0
        End If

        retErr = Tusbdam_Range_Set(DevId, ch, pol, range)

        If retErr <> 0 Then
            Tusbdam_ErrorDisp(retErr)
            DeviceClose()
        End If
    End Sub

    Private Sub DAC1SingleOut_Click(sender As System.Object, e As System.EventArgs) Handles DAC1SingleOut.Click
        '***DAC1シングル出力データ書きこみ
        Dim Ret As String
        Dim Dat As Integer
        Dim InputTxtBox As New InBox
        Dim retErr As Short

        Ret = InputTxtBox.GetText("出力値を入力してください(HEX)", "DAC1SingleOut", "0")
        If Ret.Length > 0 Then '***OKで返ってきているか
            If Integer.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, Nothing, Dat) Then
                If (Dat >= 0 And Dat <= &HFFFS) Then '*** データの範囲にあるか
                    retErr = Tusbdam_Single_Out(DevId, 1, Dat) '***DLL関数の実行
                    If retErr <> 0 Then '***DLL関数の実行
                        Tusbdam_ErrorDisp(retErr)
                        DeviceClose()
                    End If
                Else
                    MessageBox.Show("データの範囲は0～fff(HEX)です。")
                End If
            Else
                MessageBox.Show("データの形式に誤りがあります->(" & Ret & ")")
            End If
        End If
    End Sub

    Private Sub DAC2SingleOut_Click(sender As System.Object, e As System.EventArgs) Handles DAC2SingleOut.Click
        '***DAC2シングル出力データ書きこみ
        Dim Ret As String
        Dim Dat As Integer
        Dim InputTxtBox As New InBox
        Dim retErr As Short

        Ret = InputTxtBox.GetText("出力値を入力してください(HEX)", "DAC2SingleOut", "0")
        If Ret.Length > 0 Then '***OKで返ってきているか
            If Integer.TryParse(Ret, System.Globalization.NumberStyles.HexNumber, Nothing, Dat) Then
                If (Dat >= 0 And Dat <= &HFFFS) Then '*** データの範囲にあるか
                    retErr = Tusbdam_Single_Out(DevId, 2, Dat)
                    If retErr <> 0 Then '***DLL関数の実行
                        Tusbdam_ErrorDisp(retErr)
                        DeviceClose()
                    End If
                Else
                    MessageBox.Show("データの範囲は0～fff(HEX)です。")
                End If
            Else
                MessageBox.Show("データの形式に誤りがあります->(" & Ret & ")")
            End If
        End If
    End Sub

    '矩形波生成
    Private Function RectangleF(ByVal Arg As Double) As Double
        Arg /= (2.0 * Math.PI) 'スケール2Pi->1変換
        Arg -= Math.Floor(Arg) '鋸刃波形に変換
        If Arg < 0.5 Then
            Return 1.0
        Else
            Return -1.0
        End If
    End Function

    '三角波生成
    Private Function TriangleF(ByVal Arg As Double) As Double
        Arg /= (2.0 * Math.PI) 'スケール2Pi->1変換
        Arg -= Math.Floor(Arg) '鋸刃波形に変換
        Arg *= 4.0 'スケール1 -> 4変換
        If Arg < 1.0 Then
            Return Arg
        ElseIf Arg < 3.0 Then
            Return (2.0 - Arg)
        Else
            Return (Arg - 4.0)
        End If
    End Function

    '波形生成
    Private Sub GenWave(ByRef data() As Integer, ByVal Shape As Byte, ByVal Leng As Short, ByVal Amp As Short, ByVal OFFSET As Short)
        Dim cnt As Integer
        Dim angle As Double

        For cnt = 0 To (Leng - 1)
            angle = 2.0 * Math.PI * CDbl(cnt) / CDbl(Leng)
            Select Case (Shape)
                Case 0 '正弦波
                    data(cnt) = CInt(Amp * System.Math.Sin(angle) + OFFSET)
                Case 1 '三角波
                    data(cnt) = CInt(Amp * TriangleF(angle) + OFFSET)
                Case 2 '矩形波
                    data(cnt) = CInt(Amp * RectangleF(angle) + OFFSET)
                Case Else
                    data(cnt) = 0
            End Select
        Next
    End Sub

    Private Sub DACStart_Click(sender As System.Object, e As System.EventArgs) Handles DACStart.Click
        Dim i As Integer
        Dim data(8200) As Integer
        Dim retErr As Short

        If WaveSetDlg.ShowDialog() = DialogResult.OK Then

            '*** 波形発生停止(動いていた場合のため)
            retErr = Tusbdam_Stop(DevId)
            If retErr <> 0 Then '***DLL関数の実行
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            End If

            '*** サンプルクロック設定
            retErr = Tusbdam_Clock_Set(DevId, WaveSetDlg.ClkSel, WaveSetDlg.IntClock)
            If retErr <> 0 Then '***DLL関数の実行
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            End If

            '*** 波形を生成
            GenWave(data, WaveSetDlg.WaveType, WaveSetDlg.DataLen, WaveSetDlg.Amp, 2048)

            '*** DAC変換範囲に制限する処理
            For i = 0 To (WaveSetDlg.DataLen - 1)
                If data(i) > 4095 Then
                    data(i) = 4095
                ElseIf data(i) < 0 Then
                    data(i) = 0
                End If
            Next

            '*** 同期出力が有る場合の同期ビット付加
            If WaveSetDlg.SyncChk Then
                For i = 0 To (WaveSetDlg.DataLen / 2)
                    data(i) = data(i) + &H8000S
                Next
            End If

            '*** ch1メモリに波形設定
            retErr = Tusbdam_Set_Memory(DevId, 1, WaveSetDlg.DataLen, data)
            If retErr <> 0 Then
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            End If

            '*** ch2メモリに波形設定
            retErr = Tusbdam_Set_Memory(DevId, 2, WaveSetDlg.DataLen, data)
            If retErr <> 0 Then
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            End If

            '*** データ長設定
            retErr = Tusbdam_Cycle_Set(DevId, WaveSetDlg.DataLen)
            If retErr <> 0 Then
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            End If

            '*** 波形発生開始
            retErr = Tusbdam_Start(DevId, WaveSetDlg.OutputCont)
            If retErr <> 0 Then '***DLL関数の実行
                Tusbdam_ErrorDisp(retErr)
                DeviceClose()
            End If
        End If
    End Sub

    Private Sub DACSingleShot_Click(sender As System.Object, e As System.EventArgs) Handles DACSingleShot.Click
        Dim retErr As Short

        retErr = Tusbdam_Single_Shot(DevId)
        If retErr <> 0 Then '***DLL関数の実行
            Tusbdam_ErrorDisp(retErr)
            DeviceClose()
        End If
    End Sub

    Private Sub DACStop_Click(sender As System.Object, e As System.EventArgs) Handles DACStop.Click
        Dim reterr As Short

        reterr = Tusbdam_Stop(DevId)
        If reterr <> 0 Then '***DLL関数の実行
            Tusbdam_ErrorDisp(reterr)
            DeviceClose()
        End If
    End Sub

End Class
